Loading...
Searching...
No Matches
BALL::Quadruple< T1, T2, T3, T4 > Class Template Reference
Foundation Classes » General datastructures » Miscellaneous

`#include <BALL/DATATYPE/quadruple.h>`

## Public Member Functions

Constructors and Destructors
| Quadruple ()
| Quadruple (const Quadruple &quadruple, bool deep=true)
| Quadruple (const T1 &new_first, const T2 &new_second, const T3 &new_third, const T4 &new_fourth)
virtual | ~Quadruple ()
virtual void | clear ()
Assignment
const Quadruple & | operator= (const Quadruple &quadruple)
void | set (const T1 &t1, const T2 &t2, const T3 &t3, const T4 &t4)
void | get (T1 &first, T2 &second, T3 &third, T4 &fourth) const
Predicates
bool | operator== (const Quadruple &quadruple) const
bool | operator!= (const Quadruple &quadruple) const
bool | operator< (const Quadruple &quadruple) const
bool | operator<= (const Quadruple &quadruple) const
bool | operator>= (const Quadruple &quadruple) const
bool | operator> (const Quadruple &quadruple) const

## Public Attributes

Attributes
T1 | first
T2 | second
T3 | third
T4 | fourth

## Detailed Description

template<typename T1, typename T2, typename T3, typename T4>
class BALL::Quadruple< T1, T2, T3, T4 >

Quadruple Class. This template class is used to represent quadruples of arbitrary types (like the STL type pair).

Definition at line 22 of file quadruple.h.

## Constructor & Destructor Documentation

## Quadruple() [1/3]

template<typename T1, typename T2, typename T3, typename T4>

BALL::Quadruple< T1, T2, T3, T4 >::Quadruple | ( |  | ) |

Default constructor. Creates a new Quadruple object.

Definition at line 141 of file quadruple.h.

## Quadruple() [2/3]

template<typename T1, typename T2, typename T3, typename T4>

BALL::Quadruple< T1, T2, T3, T4 >::Quadruple | ( | const Quadruple< T1, T2, T3, T4 > & | quadruple,
|  | bool | deep = true )

Copy constructor. Creates a new Quadruple object from another.

Parameters

  quadruple | the Quadruple object to be copied
  deep | not used (needed for a consistent interface only)

Definition at line 146 of file quadruple.h.

## Quadruple() [3/3]

template<typename T1, typename T2, typename T3, typename T4>

BALL::Quadruple< T1, T2, T3, T4 >::Quadruple | ( | const T1 & | new_first,
|  | const T2 & | new_second,
|  | const T3 & | new_third,
|  | const T4 & | new_fourth )

Detailled constructor. Creates a new Quadruple object from the quadruple's four members.

Parameters

  new_first | the first quadruple member
  new_second | the second quadruple member
  new_third | the third quadruple member
  new_fourth | the fourth quadruple member

Definition at line 156 of file quadruple.h.

## ~Quadruple()

template<typename T1, typename T2, typename T3, typename T4>

BALL::Quadruple< T1, T2, T3, T4 >::~Quadruple | ( |  | ) |

virtual

Destructor. Destructs the Quadruple object.

Definition at line 166 of file quadruple.h.

## Member Function Documentation

## clear()

template<typename T1, typename T2, typename T3, typename T4>

BALL_INLINE void BALL::Quadruple< T1, T2, T3, T4 >::clear | ( |  | ) |

virtual

Clear method.

Definition at line 226 of file quadruple.h.

## get()

template<typename T1, typename T2, typename T3, typename T4>

BALL_INLINE void BALL::Quadruple< T1, T2, T3, T4 >::get | ( | T1 & | first,
|  | T2 & | second,
|  | T3 & | third,
|  | T4 & | fourth ) const

Definition at line 196 of file quadruple.h.

## operator!=()

template<typename T1, typename T2, typename T3, typename T4>

BALL_INLINE bool BALL::Quadruple< T1, T2, T3, T4 >::operator!= | ( | const Quadruple< T1, T2, T3, T4 > & | quadruple | ) | const

Inequality operator

Definition at line 216 of file quadruple.h.

## operator<()

template<typename T1, typename T2, typename T3, typename T4>

BALL_INLINE bool BALL::Quadruple< T1, T2, T3, T4 >::operator< | ( | const Quadruple< T1, T2, T3, T4 > & | quadruple | ) | const

Lesser than operator. One instance is lesser than an other if all members from first to third are equal or less than the members of the other instance and at least fourth is less.

Definition at line 236 of file quadruple.h.

## operator<=()

template<typename T1, typename T2, typename T3, typename T4>

BALL_INLINE bool BALL::Quadruple< T1, T2, T3, T4 >::operator<= | ( | const Quadruple< T1, T2, T3, T4 > & | quadruple | ) | const

Lesser or equal than operator.

Definition at line 248 of file quadruple.h.

## operator=()

template<typename T1, typename T2, typename T3, typename T4>

BALL_INLINE const Quadruple< T1, T2, T3, T4 > & BALL::Quadruple< T1, T2, T3, T4 >::operator= | ( | const Quadruple< T1, T2, T3, T4 > & | quadruple | ) |

Assignment operator. Assigns the contents of a quadruple to another.

Parameters

  quadruple | the quadruple to be copied

Definition at line 183 of file quadruple.h.

## operator==()

template<typename T1, typename T2, typename T3, typename T4>

BALL_INLINE bool BALL::Quadruple< T1, T2, T3, T4 >::operator== | ( | const Quadruple< T1, T2, T3, T4 > & | quadruple | ) | const

Equality operator Two instances are equal if they have the same members.

Definition at line 206 of file quadruple.h.

## operator>()

template<typename T1, typename T2, typename T3, typename T4>

BALL_INLINE bool BALL::Quadruple< T1, T2, T3, T4 >::operator> | ( | const Quadruple< T1, T2, T3, T4 > & | quadruple | ) | const

Greater than operator.

Definition at line 272 of file quadruple.h.

## operator>=()

template<typename T1, typename T2, typename T3, typename T4>

BALL_INLINE bool BALL::Quadruple< T1, T2, T3, T4 >::operator>= | ( | const Quadruple< T1, T2, T3, T4 > & | quadruple | ) | const

Greater or equal than operator.

Definition at line 260 of file quadruple.h.

## set()

template<typename T1, typename T2, typename T3, typename T4>

BALL_INLINE void BALL::Quadruple< T1, T2, T3, T4 >::set | ( | const T1 & | t1,
|  | const T2 & | t2,
|  | const T3 & | t3,
|  | const T4 & | t4 )

Definition at line 172 of file quadruple.h.

## Member Data Documentation

## first

template<typename T1, typename T2, typename T3, typename T4>

T1 BALL::Quadruple< T1, T2, T3, T4 >::first

The first quadruple member

Definition at line 124 of file quadruple.h.

## fourth

template<typename T1, typename T2, typename T3, typename T4>

T4 BALL::Quadruple< T1, T2, T3, T4 >::fourth

The fourth quadruple member

Definition at line 136 of file quadruple.h.

## second

template<typename T1, typename T2, typename T3, typename T4>

T2 BALL::Quadruple< T1, T2, T3, T4 >::second

The second quadruple member

Definition at line 128 of file quadruple.h.

## third

template<typename T1, typename T2, typename T3, typename T4>

T3 BALL::Quadruple< T1, T2, T3, T4 >::third

The third quadruple member

Definition at line 132 of file quadruple.h.